﻿using System;
using System.Drawing;

namespace PV178.Lecture2
{
    internal class Program
    {
        private static void Main(string[] args)
        {
            Console.WriteLine("Pro spuštění příslušné části zrušte odpovídající komentář v Program.cs");
            Console.WriteLine();

            // Vins();

            // Enums();

            // EnumWithFlags();

            // CarSeller();
        }

        private static void CarSeller()
        {
            Car fordMustang = new Car(new VehicleIdentificationNumber("FORD", 207666))
                                  {
                                      Color = Color.Red,
                                      Fuel = Fuel.Petrol
                                  };
            Car hondaCivic = new Car(new VehicleIdentificationNumber("Honda", 4578577), Color.Beige, Fuel.Petrol);

            CarSeller seller = new CarSeller();
            seller.Stock(fordMustang);
            seller.Stock(hondaCivic);

            SimpleInvoice invoice = seller.Sell(fordMustang, "Jan Vonásek");

            Console.WriteLine(invoice);

            Console.Write("\nStisknete ENTER pro vypis pozdnich plateb ...\n");
            Console.ReadLine();

            seller.ReportDelayedPayments();
        }

        private static void Enums()
        {
            InvoiceState state1 = InvoiceState.Active;
            Console.WriteLine("A: {0}", state1);

            InvoiceState state2 = 0;
            Console.WriteLine("B: {0}", state2);

            InvoiceState stateC = (InvoiceState) 3;
            int intC = (int) stateC;
            Console.WriteLine("C: {0}", stateC);
            Console.WriteLine("   {0}", intC);

            InvoiceState stateD = (InvoiceState) 99999;
            Console.WriteLine("D: {0}", stateD);
        }

        public static void EnumWithFlags()
        {
            Fuel fuelA = Fuel.Petrol;
            Console.WriteLine("A: {0}", fuelA);

            Fuel fuelB = Fuel.Petrol | Fuel.Oil;
            Console.WriteLine("B: {0}", fuelB);

            Fuel fuelC = Fuel.Petrol | Fuel.Lpg;
            Console.WriteLine("C: {0}", fuelC);
            // ^ vypíše PetrolHybrid protože tato položka přímo pasuje na kombinaci Petrol | Lpg.

            Fuel fuelD = (Fuel) 7;
            Console.WriteLine("D: {0}", fuelD);
            // ^ 7 = 1 (Petrol) + 2 (Oil) + 4 (LPG)

            Fuel fuelE = Fuel.Oil | Fuel.Battery;
            bool canGoOnBatteries = fuelE.HasFlag(Fuel.Battery);
            Console.WriteLine("E: {0}", canGoOnBatteries);
        }

        private static void Vins()
        {
            VehicleIdentificationNumber vin1 = new VehicleIdentificationNumber("Ford", 1562487);
            VehicleIdentificationNumber vin2 = new VehicleIdentificationNumber("Ford", 1562487);
            VehicleIdentificationNumber vin3 = new VehicleIdentificationNumber("Ford", 54244);
            VehicleIdentificationNumber vin4 = new VehicleIdentificationNumber();

            Console.WriteLine("vin1 == vin2: {0}", vin1 == vin2);
            Console.WriteLine("vin1 == vin3: {0}", vin1 == vin3);
            Console.WriteLine("vin1 == VehicleIdentificationNumber.Empty: {0}", vin1 == VehicleIdentificationNumber.Empty);
            Console.WriteLine("vin4 == VehicleIdentificationNumber.Empty: {0}", vin4 == VehicleIdentificationNumber.Empty);
        }
    }
}